(ns automata.core
  (:require [reagent.core :as reagent :refer [atom]]
            [automata.rules]
            [automata.init]))

(enable-console-print!)

;; define your app data so that it doesn't get over-written on reload
(defonce app-state (atom {
                          :text "Hello world!"
                          :rule "01101110"
                          :board [(automata.init.init-random 15)]
                          :style {
                                  :cell-size 40
                                  :border-thickness 0
                                  :active-color "red"
                                  :inactive-color "blue"
                                  }
                          }))

;(swap! app-state assoc :board [(automata.init.init-random 15)])

(defn Cell [row ind value]
  [:td
   {
    :style {:background-color (if value "red" "blue")}
    :key (str "r" row "c" ind)
    }])

(defn Row [ind row]
  [:tr
   {:key (str "row" ind)}
   (map-indexed (partial Cell ind) row)])

(defn Board []
  [:table
   (map-indexed Row (@app-state :board))])

(println "well?" (automata.rules.proc (last (@app-state :board)) (automata.rules.string-to-rule (automata.rules.preset-rules :110))))
;; this is incorrect
;(defn step []
;  (swap! app-state update-in :board conj (automata.rules.proc (last (@app-state :board)) (automata.rules.string-to-rule (automata.rules.preset-rules :110)))))

(defn App []
  [Board])

(reagent/render-component [App]
                          (. js/document (getElementById "app")))

(defn on-js-reload []
  ;; optionally touch your app-state to force rerendering depending on
  ;; your application
  ;; (swap! app-state update-in [:__figwheel_counter] inc)
)
